//
// Coordinate.java
//
package ps5;

import java.lang.String;
import java.util.Vector;
import java.util.Enumeration;

public class Coordinate {
	// OVERVIEW: A Coordinate is a mutable datatype that represents a point in 2D cartesian space.
	//     A typical coordinate is <x, y>.
	
	private int x;
	private int y;

	Coordinate(int p_x, int p_y)
	// EFFECTS: Initializes this to: <p_x, p_y>.
	{
		x = p_x;
		y = p_y;
	}

	Coordinate(Coordinate c) 
	// REQUIRES: c is not null
	// EFFECTS: Initializes this to a copy of c.
	{
		x = c.getX();
		y = c.getY();
	}

	public int getX()
	// EFFECTS: Returns the x coordinate of this.
	{
		return x;
	}

	public int getY()
	// EFFECTS: Returns the y coordinate of this
	{
		return y;
	}

	public void setX(int p_x)
	// EFFECTS: this_post = < p_x, this_pre.y >
	{
		x = p_x;
	}

	public void setY(int p_y)
	// EFFECTS: this_post = < this_pre.x, p_y >
	{
		y = p_y;
	}

	public String toString() {
		return "<" + x + ", " + y + ">";
	}

	public boolean equals(Object c) {
		if (c instanceof Coordinate) {
			Coordinate b = (Coordinate) c;
			return (x == b.getX() && y == b.getY());
		} else {
			return false;
		}
	}

	static public String outputCoordinates(Vector<Coordinate> coords) {
		StringBuffer res = new StringBuffer(coords.size() * 8);
		Enumeration<Coordinate> e = coords.elements();

		while (e.hasMoreElements()) {
			Coordinate c = (Coordinate) e.nextElement();
			res.append(c.x + "," + c.y + ";");
		}

		return new String(res);
	}
}
