package ps5;

abstract public class MobileSimObject extends SimObject {
	// OVERVIEW: A MobileSimObject is a simulator object that can move.
	//    Note: its still an abstract class since we didn't implement executeTurn.

	synchronized public void setLocation(int newx, int newy) throws BadLocationException
	// REQUIRES: The square in the grid at newrow, newcol is empty.
    //           this is initialized.						      
	// MODIFIES: this
	// EFFECTS: If newx, newy is not a valid location, throws BadLocationException.
	//            Otherwise, sets the location of this to newx, newy.
	{ 
		if (grid.getObjectAt(newx, newy) != null) { 
			throw new RuntimeException(
				"BUG: SimObject.setLocation - "
					+ newx
					+ ", "
					+ newy
					+ " already occupied.");
		}

		// Empty location, move to it.
		grid.removeObjectAt(mx, my); 
		grid.setObjectAt(newx, newy, this);
		mx = newx;
		my = newy;
	} 
}
