package ps5;

import java.awt.Color;

public class RandomWalker extends MobileSimObject {
	// OVERVIEW: A RandomWalker is a drunk simulator object that performace a
	// random walk, moving one square in a random direction each step.

	// Currently in the middle of a turn (used for coloring)
	private boolean inTurn;

	public RandomWalker() {
		inTurn = false;
	}

	public void executeTurn() throws RuntimeException
	// Note: requires isInitialized is inherited from SimObject
	// EFFECTS: Picks a random direction and tries to move that way.
	// If the move is successful, return true. If the move fails
	// because the spot being attempted to move into is already
	// occupied then return false.

	{
		inTurn = true;
		Direction dir = Direction.randomDirection();
		int newy = getY() + dir.northerlyDirection();
		int newx = getX() + dir.easterlyDirection();

		if (getGrid().validLocation(newx, newy)) {
			try {
				if (getGrid().isSquareEmpty(newx, newy)) {
					// Here, we pretend there is a lot of compution to do by
					// sleeping,
					// to make race conditions more likely.
					delay(500);

					setLocation(newx, newy);
				}
			} catch (BadLocationException ble) {
				throw new RuntimeException(ble);
			}
		}

		inTurn = false;
	}

	public Color getColor() {
		if (inTurn) {
			return Color.white;
		} else {
			return Color.cyan;
		}
	}
}
