package ps5;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class MouseHandler implements MouseListener {
	private GridDisplay grid;
	// Rep Invariant: grid != null

	public MouseHandler(GridDisplay display) {
		super();
		grid = display;
	}

	public void mousePressed(MouseEvent e) {
		;
	}

	public void mouseReleased(MouseEvent e) {
		;
	}

	public void mouseEntered(MouseEvent e) {
		;
	}

	public void mouseExited(MouseEvent e) {
		;
	}

	public void mouseClicked(MouseEvent e) {
		grid.setObjectAt(e.getX(), e.getY());
	}
}

public class Simulator extends JPanel implements ActionListener {
	private static final long serialVersionUID = 1L;

	// Rep:
	protected GridDisplay display;
	protected SimObjectChooser simObjChooser;
	private JButton startButton, stopButton;

	public Simulator(int width, int height, Grid grid) {
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		simObjChooser = new SimObjectChooser();
		display = new GridDisplay(grid, simObjChooser);
		display.setPreferredSize(new Dimension(width, height));
		display.setMinimumSize(new Dimension(width, height));
		display.addMouseListener(new MouseHandler(display));
		add(display);

		JPanel panel1 = new JPanel();
		panel1.add(new JLabel("Place Object: "));
		panel1.add(simObjChooser);

		startButton = new JButton("Start");
		// place button at center, left position
		startButton.setVerticalTextPosition(AbstractButton.CENTER);
		startButton.setHorizontalTextPosition(AbstractButton.LEFT);
		startButton.setMnemonic(KeyEvent.VK_D);
		startButton.setActionCommand("start");

		stopButton = new JButton("Stop");
		// Use the default button position of CENTER, RIGHT.
		stopButton.setMnemonic(KeyEvent.VK_E);
		stopButton.setActionCommand("stop");
		stopButton.setEnabled(false);

		// Listen for actions on the Start and Stop buttons.
		startButton.addActionListener(this);
		stopButton.addActionListener(this);

		panel1.add(simObjChooser);
		panel1.add(startButton);
		panel1.add(stopButton);

		add(panel1);
	}

	public void addClass(String s) {
		try {
			simObjChooser.addClass(s);
		} catch (ClassNotFoundException e) {
			if (!s.contains(".")) {
				System.err.println("Error loading simulated object class " + s
						+ " (missing package name?): " + e);				
			} else {
				System.err.println("Error loading simulated object class " + s
									+ ": " + e);
			}
		}
	}

	public void actionPerformed(ActionEvent e) 
	// REQUIRES: e != null
	{
		String command = e.getActionCommand();

		if (command != null) {
			if (command.equals("start")) {
				startButton.setEnabled(false);
				stopButton.setEnabled(true);
				display.startObjects();
			} else if (command.equals("stop")) {
				startButton.setEnabled(true);
				stopButton.setEnabled(false);
				display.pauseObjects();
			}
		} else {
			System.err.println("Null command: " + e);
		}
	}
}
